#!/bin/env python

import pIPC, thread, os
from select import select
from thread import start_new_thread, exit_thread
from time   import sleep

#-----------------------------------------------------------------------

def threadfunc(ipc):
  try:
    count = 0
    ipc.write("Hello")
    while 1:
      r,w,x = select([ipc],[],[],1)
      if r != []:
        for data in ipc.pending():             # get all pending messages
          print "IPC message from MAIN:",data
          if data[-1] == "?":
            ipc.write("Yes MAIN, I am here!")  # Answer questions
        sleep(1)
      else:
        ipc.write("Hello main, are you there?")
        count = count + 1
        if count > 4:
          ipc.disconnect("I have lived too long. See you!")
          sleep(1)
          exit_thread()
  finally:
    if ipc.is_connected():
      ipc.disconnect("Error")
    sleep(1)
    print "thread is now exiting"
    exit_thread()

#-----------------------------------------------------------------------

ipc = pIPC.Pipe()

try:
  ipc.write("Hello")
  while 1:
    while ipc.is_connected():
      r,w,x = select([ipc],[],[],1)
      if r != []:
        for data in ipc.pending():
          if data[:3] == "BYE":
            print "MAIN: External thread has ended with message:",data[3:]
          else:
            print "IPC message from THREAD:",data
            if data[-1] == "?":
              ipc.write("Yes THREAD, I am here!")
        sleep(1)
      else:
        ipc.write("Hello thread, are you there?")
        sleep(1)
    print "Use CTRL-C to end this example"
    start_new_thread(threadfunc,(ipc,))
    sleep(2)

finally:
   print "main is now exiting."
   ipc.write("END")
   sleep(1)
   ipc.close()

